
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; For MULE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;(set-display-coding-system *euc-kr*)
;(set-keyboard-coding-system *euc-kr*)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; For GNU HanEmacs
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; set input mode
(cond 
 ((and 
     (boundp 'emacs-major-version)
     (= emacs-major-version 19)
     (= emacs-minor-version 34))
  (standard-display-european t)
  (set-input-mode (car (current-input-mode)) (nth 1 (current-input-mode)) 0)
))
;;;===========

;; set hostname as window title
(defvar AJK::hostname (getenv "HOST")
	"Automagically set to hostname running Emacs.")
(setq screen-icon-title-format (concat AJK::hostname ": %b"))
(setq screen-title-format      (concat AJK::hostname ": %b"))
(setq line-number-mode t)    ;; line number in the mode line
 
;; C and C++ mode
;;; ********************
;;; Load much improved versions of the C and C++ modes.  At some point this
;;; will become the default in Lucid Emacs.
;;;
;(fmakunbound 'c-mode)
;(fmakunbound 'c++-mode)
;(makunbound 'c-mode-map)
;(makunbound 'c++-mode-map)
;(makunbound 'c-style-alist)

;(autoload 'c++-mode "cc-mode" "C++ Editing Mode" t)
;(autoload 'c-mode   "cc-mode" "C Editing Mode" t)

;
; swap the Backspace and Delete keys(This is for terminal mode)
;
(keyboard-translate ?\C-h ?\C-?)
(keyboard-translate ?\C-? ?\C-h)

;(require 'tex-site)
(setq auto-mode-alist (mapcar 'purecopy
		      '(("\\.c$" . c-mode)
			("\\.cc$" . c-mode)
		        ("\\.C$" . c-mode)
			("\\.h$" . c-mode)
			("\\.hh$" . c-mode)
			("\\.tex$" . latex-mode)
			("\\.ks$" . latex-mode)
			("\\.txi$" . Texinfo-mode)
			("\\.el$" . emacs-lisp-mode)
			("\\.a$" . c-mode))))

;
; fontlock mode
;
(add-hook 'c-mode-hook 'turn-on-font-lock)
(add-hook 'c++-mode-hook 'turn-on-font-lock)
(add-hook 'lisp-mode-hook 'turn-on-font-lock)
(add-hook 'emacs-lisp-mode-hook 'turn-on-font-lock)
(require 'font-lock)

;
; set news server
;(setq gnus-nntp-server "news.snu.ac.kr")
