/* ѱ 2 丶Ÿ. 
   Copyright (C) 1994, 95, 96 ϴϸ  (fpf545@dosa1.snu.ac.kr).

   Emacs ҽ ڵ忡 ѱ ó   κ hanemacs 
   ũθ ϰ ֽϴ.  κ   ȭϰ Բ 
   ϴϸ ҽ ڵ ֵ˴ϴ.

HanEmacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

HanEmacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <config.h>
#include "hangul.h"

#define TRUE  1
#define FALSE 0

enum han_status 
{
  hs_start, 
  hs_chosung,
  hs_joongsung, hs_djoongsung,
  hs_jongsung, hs_djongsung,
  hs_end1, hs_end2
};

enum han_chkind { consonant, vowel };

static unsigned code;
static unsigned oldkey;
static unsigned keycode;

static int 
joongsung_pair (void)
{
  static unsigned char djoong_table[7][3] = 
    {
      0xad, 0xa3, 0xae,               /* , ,  */
      0xad, 0xa4, 0xaf,               /* , ,  */
      0xad, 0xbd, 0xb2,               /* , ,  */
      0xb4, 0xa7, 0xb5,               /* , ,  */
      0xb4, 0xaa, 0xb6,               /* , ,  */
      0xb4, 0xbd, 0xb7,               /* , ,  */
      0xbb, 0xbd, 0xbc                /* , ,  */
    };
  int i;
  
  for (i = 0; i < 7; i++) 
    {
      if (djoong_table[i][0] == oldkey && djoong_table[i][1] == keycode)
	return (int) (keycode = djoong_table[i][2]);
    }

  return 0;
}

static int 
jongsung_pair (void)
{
  static unsigned char djong_table[11][3] = {
    0x82, 0x8b, 0xc4,               /* ⿪, ÿ */
    0x84, 0x8e, 0xc6,               /* ,  */
    0x84, 0x94, 0xc7,               /* ,  */
    0x87, 0x82, 0xca,               /* , ⿪ */
    0x87, 0x88, 0xcb,               /* ,  */
    0x87, 0x89, 0xcc,               /* ,  */
    0x87, 0x8b, 0xcd,               /* , ÿ */
    0x87, 0x92, 0xce,               /* , Ƽ */
    0x87, 0x93, 0xcf,               /* ,  */
    0x87, 0x94, 0xd0,               /* ,  */
    0x89, 0x8b, 0xd4,               /* , ÿ */
  };
  int i;
  
  for (i = 0; i < 11; i++) 
    {
      if (djong_table[i][0] == oldkey && djong_table[i][1] == keycode)
	return (int) (keycode = djong_table[i][2]);
    }

  return 0;
}

unsigned
hangul_automata_2 (hfrm, key)
     struct hangul_automata_state *hfrm;
     unsigned key;
{
  int chkind, canbejongsung = FALSE;
  static unsigned char cho2jong[] = {      /* ʼ ڵ忡 ϴ  ڵ */
    0xc2,   /*  ⿪                                */
    0xc3,   /*  ֱ⿪                              */
    0xc5,   /*                                  */
    0xc8,   /*                                  */
    0x00,   /*  ֵ (ش )  */
    0xc9,   /*                                  */
    0xd1,   /*                                  */
    0xd3,   /*                                  */
    0x00,   /*   (ش )  */
    0xd5,   /*  ÿ                                */
    0xd6,   /*  ֽÿ                              */
    0xd7,   /*                                  */
    0xd8,   /*                                  */
    0x00,   /*   (ش )  */
    0xd9,   /*  ġ                                */
    0xda,   /*  Ű                                */
    0xdb,   /*  Ƽ                                */
    0xdc,   /*                                  */
    0xdd    /*                                  */
  };

  if ((key & 0x60) == 0x20) 
    chkind = vowel;
  else 
    {
      chkind = consonant;
      if (!(key == 0x86 || key == 0x8a || key == 0x8f))
	canbejongsung = TRUE;
    }

  if (hfrm->AMstate) 
    {
      code = hfrm->input_stack[hfrm->input_sp -1].code;
      oldkey = hfrm->input_stack[hfrm->input_sp -1].key;
    } 
  else 
    {
      code = 0x8441;
      oldkey = 0;
    }

  keycode = key;

  switch (hfrm->AMstate) 
    {
    case hs_start:
      hfrm->AMstate = (chkind == consonant ? hs_chosung :hs_joongsung);
      break;
    case hs_chosung:
      hfrm->AMstate = (chkind == vowel ? hs_joongsung : hs_end1);
      break;
    case hs_joongsung:
      hfrm->AMstate = (canbejongsung ? hs_jongsung :
			       (joongsung_pair() ? hs_djoongsung : hs_end1));
      break;
    case hs_djoongsung:
      hfrm->AMstate = (canbejongsung ? hs_jongsung : hs_end1);
      break;
    case hs_jongsung:
      hfrm->AMstate = 
	(chkind == consonant && jongsung_pair() ? hs_djongsung :
	 (chkind == vowel ? hs_end2 : hs_end1));
      break;
    case hs_djongsung:
      hfrm->AMstate = (chkind == vowel ? hs_end2 : hs_end1);
      break;
    }
  
  switch (hfrm->AMstate) 
    {
    case hs_chosung:
      code = (code & 0x83ff) | ((keycode - 0x80) << 10);
      break;
    case hs_joongsung:
    case hs_djoongsung:
      code = (code & 0xfc1f) | ((keycode - 0xa0) << 5);
      break;
    case hs_jongsung:
      keycode = cho2jong[keycode - 0x82];
    case hs_djongsung:
      code = (code & 0xffe0) | (keycode - 0xc0);
      break;
    case hs_end1:
      hfrm->output_stack[hfrm->output_sp++] = key;
      return TRUE;
    case hs_end2:
      hfrm->output_stack[hfrm->output_sp++] = key;
      hfrm->output_stack[hfrm->output_sp++] = oldkey;
      hfrm->input_sp--;
      return TRUE;
    }

  hfrm->input_stack[hfrm->input_sp].amstate = hfrm->AMstate;
  hfrm->input_stack[hfrm->input_sp].code = code;
  hfrm->input_stack[hfrm->input_sp++].key = key;

  return FALSE;
}
