/* ѱ 3 丶Ÿ.
   Copyright (C) 1994, 95, 96 ϴϸ  (fpf545@dosa1.snu.ac.kr).

   Emacs ҽ ڵ忡 ѱ ó   κ hanemacs 
   ũθ ϰ ֽϴ.  κ   ȭϰ Բ 
   ϴϸ ҽ ڵ ֵ˴ϴ.

HanEmacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

HanEmacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <config.h>
#include "hangul.h"

#define TRUE  1
#define FALSE 0

enum han_status 
{
  hs_start,
  hs_chosung,   hs_dchosung,
  hs_joongsung, hs_djoongsung,
  hs_jongsung,  hs_djongsung,
  hs_end
};

enum han_chkind 
{
  chosung   = 0x00,
  joongsung = 0x20,
  jongsung  = 0x40
};

static unsigned code;
static unsigned oldkey;
static unsigned keycode;

static int 
chosung_pair (void)
{
  static unsigned char dcho_table[][3] = 
    {
      0x82, 0x82, 0x83,               /* ⿪, ⿪, ֱ⿪ */
      0x85, 0x85, 0x86,               /* , , ֵ */
      0x89, 0x89, 0x8a,               /* , , ֺ */
      0x8b, 0x8b, 0x8c,               /* ÿ, ÿ, ֽÿ */
      0x8e, 0x8e, 0x8f                /* , ,  */
    };
  int i;
  
  for (i = 0; i < 5; i++) 
    {
      if (dcho_table[i][0] == oldkey && dcho_table[i][1] == keycode)
	return (int) (keycode = dcho_table[i][2]);
    }

  return 0;
}

static int 
joongsung_pair (void)
{
  static unsigned char djoong_table[][3] = 
    {
      0xad, 0xa3, 0xae,               /* , ,  */
      0xad, 0xa4, 0xaf,               /* , ,  */
      0xad, 0xbd, 0xb2,               /* , ,  */
      0xb4, 0xa7, 0xb5,               /* , ,  */
      0xb4, 0xaa, 0xb6,               /* , ,  */
      0xb4, 0xbd, 0xb7,               /* , ,  */
      0xbb, 0xbd, 0xbc                /* , ,  */
    };
  int i;
  
  for (i = 0; i < 7; i++) 
    {
      if (djoong_table[i][0] == oldkey && djoong_table[i][1] == keycode)
	return (int) (keycode = djoong_table[i][2]);
    }

  return 0;
}

static int 
jongsung_pair(void)
{
  static unsigned char djong_table[][3] = 
    {
      0xc2, 0xc2, 0xc3,               /* ⿪, ⿪ */
      0xc2, 0xd5, 0xc4,               /* ⿪, ÿ */
      0xc5, 0xd8, 0xc6,               /* ,  */
      0xc5, 0xdd, 0xc7,               /* ,  */
      0xc9, 0xc2, 0xca,               /* , ⿪ */
      0xc9, 0xd1, 0xcb,               /* ,  */
      0xc9, 0xd3, 0xcc,               /* ,  */
      0xc9, 0xd5, 0xcd,               /* , ÿ */
      0xc9, 0xdb, 0xce,               /* , Ƽ */
      0xc9, 0xdc, 0xcf,               /* ,  */
      0xc9, 0xdd, 0xd0,               /* ,  */
      0xd3, 0xd5, 0xd4,               /* , ÿ */
      0xd5, 0xd5, 0xd6                /* ÿ, ÿ */
    };
  int i;
  
  for (i = 0; i < 13; i++) 
    {
      if (djong_table[i][0] == oldkey && djong_table[i][1] == keycode)
	return (int) (keycode = djong_table[i][2]);
    }

  return 0;
}

unsigned
hangul_automata_3 (hfrm, key)
     struct hangul_automata_state *hfrm;
     unsigned key;
{
  int chkind = key & 0x60;
  
  if (hfrm->AMstate) 
    {
      code = hfrm->input_stack[hfrm->input_sp -1].code;
      oldkey = hfrm->input_stack[hfrm->input_sp -1].key;
    }
  else
    {
      code = 0x8441;
      oldkey = 0;
    }

  keycode = key;

  switch (hfrm->AMstate) 
    {
    case hs_start:
      switch (chkind) 
	{
	case chosung:
	  hfrm->AMstate = hs_chosung;
	  break;
	case joongsung:
	  hfrm->AMstate = hs_joongsung;
	  break;
	case jongsung:
	  hfrm->AMstate = hs_jongsung;
	  break;
	}
      break;

    case hs_chosung:
      switch (chkind) 
	{
	case chosung:
	  if (chosung_pair())
	    hfrm->AMstate = hs_dchosung;
	  else
	    hfrm->AMstate = hs_end;
	  break;
	case joongsung:
	  hfrm->AMstate = hs_joongsung;
	  break;
	case jongsung:
	  hfrm->AMstate = hs_jongsung;
	  break;
	}
      break;

    case hs_dchosung:
      switch (chkind) 
	{
	case chosung:
	  hfrm->AMstate = hs_end;
	  break;
	case joongsung:
	  hfrm->AMstate = hs_joongsung;
	  break;
	case jongsung:
	  hfrm->AMstate = hs_jongsung;
	  break;
	}
      break;

    case hs_joongsung:
      switch (chkind) 
	{
	case chosung:
	  hfrm->AMstate = hs_end;
	  break;
	case joongsung:
	  if (joongsung_pair())
	    hfrm->AMstate = hs_djoongsung;
	  else
	    hfrm->AMstate = hs_end;
	  break;
	case jongsung:
	  hfrm->AMstate = hs_jongsung;
	  break;
	}
      break;

    case hs_djoongsung:
      switch (chkind) 
	{
	case chosung:
	case joongsung:
	  hfrm->AMstate = hs_end;
	  break;
	case jongsung:
	  hfrm->AMstate = hs_jongsung;
	  break;
	}
      break;

    case hs_jongsung:
      switch (chkind) 
	{
	case chosung:
	case joongsung:
	  hfrm->AMstate = hs_end;
	  break;
	case jongsung:
	  if (jongsung_pair())
	    hfrm->AMstate = hs_djongsung;
	  else
	    hfrm->AMstate = hs_end;
	  break;
	}
      break;

    case hs_djongsung:
      hfrm->AMstate = hs_end;
      break;
    }
  
  switch (hfrm->AMstate) 
    {
    case hs_chosung:
    case hs_dchosung:
      code = (code & 0x83ff) | ((keycode - 0x80) << 10);
      break;
    case hs_joongsung:
    case hs_djoongsung:
      code = (code & 0xfc1f) | ((keycode - 0xa0) << 5);
      break;
    case hs_jongsung:
    case hs_djongsung:
      code = (code & 0xffe0) | (keycode - 0xc0);
      break;
    case hs_end:
      hfrm->output_stack[hfrm->output_sp++] = key;
      return TRUE;
    }

  hfrm->input_stack[hfrm->input_sp].amstate = hfrm->AMstate;
  hfrm->input_stack[hfrm->input_sp].code = code;
  hfrm->input_stack[hfrm->input_sp++].key = key;

  return FALSE;
}
