/* ѱ ó  ٽ κ. ѱ 丶Ÿ,  , ѱ ĳ...
   Copyright (C) 1994, 95, 96 ϴϸ  (fpf545@dosa1.snu.ac.kr).

   Emacs ҽ ڵ忡 ѱ ó   κ hanemacs 
   ũθ ϰ ֽϴ.  κ   ȭϰ Բ 
   ϴϸ ҽ ڵ ֵ˴ϴ.

HanEmacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

HanEmacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <config.h>
#include "lisp.h"
#include "intervals.h"
#include "buffer.h"
#include "window.h"
#include "blockinput.h"

#include "hangul.h"

#ifdef 0
#include "stdio.h"
#include "unistd.h"
#include "fcntl.h"
#endif

#define TRUE 1
#define FALSE 0

#define min(a,b)        ((a)<(b)?(a):(b))
#define max(a,b)        ((a)>(b)?(a):(b))
#define abs(a)          ((a)>0?(a):-(a))

int record_toggling;
int han_johab_mode;     /* default KSC5601 */

int han_kbd_kind;         /* default 2 bulsik */
int han_kbd_state;        /* default English */
static int han_old_kbd_state;

/* Ʒ  hangul_frame ѱ ڵ ¸ Ÿ    */
int han_code_state;

#ifdef HAVE_X_WINDOWS
static struct hangul_automata_state current_buffer_hangul_frame;
static struct hangul_automata_state external_buffer_hangul_frame;

/* ------------------------------------- */
/*  Common routines for hangul automata  */
/* ------------------------------------- */
 
void init_current_buffer_automata ();
void init_external_buffer_automata ();


void 
save_kbd_state (void)
{ 
  han_old_kbd_state = han_kbd_state;
  han_kbd_state = 0; 
}

void
restore_kbd_state (void)
{ 
  han_kbd_state = han_old_kbd_state; 
}

void 
toggle_kbd_state (void)
{
  record_toggling = 1;
  han_kbd_state = !han_kbd_state;
  init_current_buffer_automata ();
  init_external_buffer_automata ();
}
#endif /* HAVE_X_WINDOWS */

void
erase_toggling (void)
{
  record_toggling = 0;
}

void
make_han_message (msg)
     unsigned char *msg;
{
#ifndef HAVE_X_WINDOWS
  if (han_johab_mode)
    strcpy (msg, "");
  else 
    strcpy (msg, "");
#else
  if (inhibit_window_system)
    {
      if (han_johab_mode)
	strcpy (msg, "");
      else 
	strcpy (msg, "");
      return;
    }
 
  if (han_johab_mode)
    {
      if (han_kbd_state)
	strcpy (msg, "e");
      else 
	strcpy (msg, "w");
      
      if (han_johab_mode)
	strcat (msg, "/");
      else 
	strcat (msg, "/");
      
      if (han_kbd_kind == 3)
	strcat (msg, "/3");
      else 
	strcat (msg, "/2");
    }
  else
    {
      if (han_kbd_state)
	strcpy (msg, "");
      else 
	strcpy (msg, "");
      
      if (han_johab_mode)
	strcat (msg, "/");
      else 
	strcat (msg, "/");
      
      if (han_kbd_kind == 3)
	strcat (msg, "/3");
      else 
	strcat (msg, "/2");
    }
#endif /* HAVE_X_WINDOWS */
}

unsigned 
make_code_with_string (str)
     unsigned char *str;
{
  return (unsigned) (str[0] * 256 + str[1]);
}

unsigned
make_jcode_with_string (str)
     unsigned char *str;
{
  unsigned code = (unsigned) (str[0] * 256 + str[1]);
  return (han_johab_mode ? code : convert_ks_to_johab_code (code));
}

int
make_string_with_code (code, str)
     unsigned code;
     unsigned char *str;
{
  unsigned lo, hi;

/*  if (code < 256 && code > 0) */
  if (code < 256)
    {
      str[0] = (unsigned char) code;
      str[1] = '\0';
      return 1;
    }

  hi = code >> 8;
  lo = code & 0x00ff;
  str[0] = (unsigned char) hi;
  str[1] = (unsigned char) lo;
  str[2] = '\0';
  return 2;
}

#ifdef HAVE_X_WINDOWS
static void
init_hangul_automata (hfrm)
     struct hangul_automata_state *hfrm;
{
  hfrm->AMstate = 0;
  hfrm->input_sp = 0;
}

static unsigned
hangul_automata (hfrm, key)
     struct hangul_automata_state *hfrm;
     unsigned key;
{
  return (han_kbd_kind == 3 ? hangul_automata_3 (hfrm, key) : hangul_automata_2 (hfrm, key));
}

static int
get_hangul_code (hfrm, key, fcode, scode)
     struct hangul_automata_state *hfrm;
     unsigned key, *fcode, *scode;
{
  int t, s, result;
  unsigned newkey;
  unsigned code1=0, code2=0;

  code1 = newkey = convert_ascii_for_hangul_keyboard (key);

  if (!newkey) 
    /* delete or backspace one component of hangul character */
    {
      if (hfrm->input_sp) /* when automaton is being activated */
	{
	  hfrm->input_sp--;
	  if (hfrm->input_sp)
	    {
	      hfrm->AMstate = hfrm->input_stack[hfrm->input_sp -1].amstate;
	      code1 = (han_johab_mode ? 
		       hfrm->input_stack[hfrm->input_sp -1].code : 
		       convert_johab_to_ks_code (hfrm->input_stack[hfrm->input_sp -1].code));
	      result = code_hanbs;
	    }
	  else /* completely deleted */
	    {
	      init_hangul_automata (hfrm);
	      result = code_nohan;
	    }
	}
      else /* when automaton is not being activated;
	    * type backspace behind ascii or C-d */
	result = code_delete;
    }

  else if (newkey > 127 && newkey < 256)
    /* automaton should take care of this key. be activated! */
    {
      s = hfrm->AMstate;
      t = hangul_automata (hfrm, newkey);
      code1 = (han_johab_mode ? 
	       hfrm->input_stack[hfrm->input_sp -1].code : 
	       convert_johab_to_ks_code (hfrm->input_stack[hfrm->input_sp -1].code));
      
      if (!code1)	  
	/* wansung code doesn't exist corresponding to the johab code;
	 * for example, ++-> /*/
	{
	  code1 = (han_johab_mode ? 
		   hfrm->input_stack[hfrm->input_sp -2].code :
		   convert_johab_to_ks_code (hfrm->input_stack[hfrm->input_sp -2].code));
	  init_hangul_automata (hfrm);
	  hangul_automata (hfrm, newkey);
	  code2 = (han_johab_mode ? 
		   hfrm->input_stack[hfrm->input_sp -1].code : 
		   convert_johab_to_ks_code (hfrm->input_stack[hfrm->input_sp -1].code));
	  result = code_hanend;
	}
      else if (t) /* just now, first code completely generated */
	{
	  init_hangul_automata (hfrm);
	  while (hfrm->output_sp)
	    hangul_automata (hfrm, hfrm->output_stack[--(hfrm->output_sp)]);
	  
	  code2 = (han_johab_mode ?
		   hfrm->input_stack[hfrm->input_sp -1].code :
		   convert_johab_to_ks_code (hfrm->input_stack[hfrm->input_sp -1].code));
	  result = code_hanend;
	}
      else if (!s)
	result = code_hanst;
      else
	result = code_hanin;
    }

  else if (hfrm->AMstate)
    /* where automaton is being activated, be forced to insert ascii code */
    {
      code1 = (han_johab_mode ?
	       hfrm->input_stack[hfrm->input_sp -1].code :
	       convert_johab_to_ks_code (hfrm->input_stack[hfrm->input_sp -1].code));
      code2 = newkey;
      
      init_hangul_automata (hfrm);
      result = code_hanend;
    }

  else 
    /* where automaton is not being activated, just insert ascii code */
    result = code_ascii;

  *fcode = code1;
  *scode = code2;

  return (hfrm->CDstate = result);
}


/* ---------------------------- */
/*  Hangul routines for BUFFER  */
/* ---------------------------- */

static void 
insert_and_inherit_hangul (str, len, action)
     unsigned char *str;
     int len, action;
{
  int ok=0;

  if (action && PT > BEGV +1)
    {
      SET_PT (PT - 2);
      ok = 1;
    }

  insert_1 (str, len, 1, 1, 0);
  signal_after_change (PT-len, 0, len);

  if (action && ok)
    del_range (PT, PT + 2);
}

void
init_current_buffer_automata (void)
{
  init_hangul_automata (&current_buffer_hangul_frame);
}

int
insert_hangul (string, length)
     register unsigned char *string;
     register length;
{
  unsigned code1, code2;
  unsigned char ch;
  static unsigned char str[10];
  /* fixed by dwpark */
  /* static int half_hangul_history; */
  static int half_hangul_history = 0;

  int len=0, isbs=0;
  /* ISBS indicate that internal_self_insert () don't change hairy,
     change it only if isbs > 0 */

  /* LENGTH must be always '1' */ 
  if (length < 1) 
    return;

  ch = (string ? string[0] : 0); /* BackSpace or CTRL-D */

  if (!han_kbd_state)
    {
      /* An half hangul can be inserted in a session logged remotely
	 through hanterm, so we need to guarantee 
	 that an half hangul not be inserted alone. */
      if (half_hangul_history)
	{
	  str[1] = ch;
	  /* fixed by dwpark */
	  /* insert_and_inherit (str, 2, 1); */
	  insert_and_inherit (str, 2);
	  half_hangul_history = 0;
	  return 1;
	}
      else if (ch & 0x80)
	{
	  str[0] = ch;
	  half_hangul_history = 1;
	  return 1;
	}
      else
	{
	  /* fixed by dwpark */
	  /* insert_and_inherit (string, length, 1); */
	  insert_and_inherit (string, length);
	  return 0;
	}
    }

  switch (get_hangul_code (&current_buffer_hangul_frame, ch, &code1, &code2))
    {
    case code_hanst:
      len = make_string_with_code (code1, str);
      insert_and_inherit_hangul (str, len, 0);
      isbs = 1; 
      break;
      
    case code_hanin:
      len = make_string_with_code (code1, str);
      insert_and_inherit_hangul (str, len, 1);
      isbs = 1; 
      break;
      
    case code_hanend:
      len = make_string_with_code (code1, str);
      insert_and_inherit_hangul (str, len, 1);
      len = make_string_with_code (code2, str);
      insert_and_inherit_hangul (str, len, 0);
      isbs = 1; 
      break;
      
    case code_hanbs:
      len = make_string_with_code (code1, str);
      insert_and_inherit_hangul (str, len, 1);
      isbs = 2; /* indicate that del_range_1 () not be performed! */
      break;
      
    case code_ascii: /* 3 Bulsik needs the following code */
      len = make_string_with_code (code1, str);
      insert_and_inherit_hangul (str, len, 0);
      isbs = 0;
      break;

    /* default: */
    /* code_nohan || code_delete */
    }

  han_code_state = current_buffer_hangul_frame.CDstate;
  return isbs;
}


/* ---------------------------------------- */
/*  Hangul routines for incremental search  */
/* ---------------------------------------- */

void
init_external_buffer_automata (void)
{
  init_hangul_automata (&external_buffer_hangul_frame);
}

static int
generate_hangul (string, ch)
     register unsigned char *string;
     register unsigned char ch;
{
  unsigned code1, code2;
  unsigned char str[10];
  int len, tlen=0;

  if (!han_kbd_state)
    return 0;

  switch (get_hangul_code (&external_buffer_hangul_frame, ch, &code1, &code2))
    {
    case code_ascii:
      len = make_string_with_code (code1, str);
      strcpy (string, str);
      tlen += len;
      break;

    case code_hanend:
      len = make_string_with_code (code1, str);
      strcpy (string, str);
      tlen += len;
      len = make_string_with_code (code2, str);
      strcat (string, str);
      tlen += len;
      break;

    default: /* code_hanst || code_hanin */
      len = make_string_with_code (code1, str);
      strcpy (string, str);
      tlen += len;

      /* code_hanbs || code_nohan || code_delete never happen. */
    }

  han_code_state = external_buffer_hangul_frame.CDstate;
  return tlen;
}

DEFUN ("han-activate-automata", Fhan_activate_automata, Shan_activate_automata,
       1, 1, 0, "Էµ Ű ѱ ڿ Ѵ.")
     (key)
     Lisp_Object key;
{
  unsigned char string[10];
  int len;

  if (han_kbd_state)
    {
      len = generate_hangul (string, XINT (key));
      return make_string (string, len);
    }
  else
    {
      string[0] = (unsigned char) XINT (key);
      return make_string (string, 1);
    }
}

int
reactivate_automata (code)
     unsigned code;
{
  unsigned char string[10], keys[10];
  int i, n, jstate;

  if (code <= 0)
    return -1;

  n = lookup_ascii_for_hangul_keyboard (code, keys, &jstate);
  init_external_buffer_automata ();

  for (i = 0; i < n; i++)
    generate_hangul (string, keys[i]);

  return jstate;
}

/* isearch-delete-char () call me */
DEFUN ("han-reactivate-automata", Fhan_reactivate_automata,
       Shan_reactivate_automata, 1, 1, 0,
       "external buffer  ڸ ѱ  · .")
     (string)
     Lisp_Object string;
{
  Lisp_Object substr;
  unsigned code;
  unsigned char *str = XSTRING (string)->data;
  int len = XSTRING (string)->size;

  if (!han_kbd_state)
    return Qnil;

  /* if backspace is repeated, isearch-string will be nil, clear the stack. */
  if (len < 2)
    init_external_buffer_automata ();
  
  else if (char_kind_in_given_string (str, len-2) == ck_han1)
    /* isearch-string ended with hangul code */
    {
      substr = Fsubstring (string, make_number (len-2), make_number (len));
      if (!(code = make_jcode_with_string (XSTRING (substr)->data)))
	return Qnil;
      if (reactivate_automata (code) < 0)
	return Qnil;
      
      return Qt;
    }
  else
    return Qnil;
}


DEFUN ("han-init-automata", Fhan_init_automata, Shan_init_automata, 
       0, 0, 0, "external buffer  ѱ 丶Ÿ ʱȭѴ.")
     ()
{
  init_external_buffer_automata ();
  return Qt;
}
#else
DEFUN ("han-activate-automata", Fhan_activate_automata, Shan_activate_automata,
       1, 1, 0, "Էµ Ű ڿ Ѵ.")
     (key)
     Lisp_Object key;
{
  unsigned char string[10];
  int len;

  string[0] = (unsigned char) XINT (key);
  return make_string (string, 1);
}
/* isearch-delete-char () call me */
DEFUN ("han-reactivate-automata", Fhan_reactivate_automata,
       Shan_reactivate_automata, 1, 1, 0,
       "external buffer  ڸ ѱ  · .")
     (string)
     Lisp_Object string;
{
  return Qnil;
}
DEFUN ("han-init-automata", Fhan_init_automata, Shan_init_automata, 
       0, 0, 0, "external buffer  ѱ 丶Ÿ ʱȭѴ.")
     ()
{
  return Qnil;
}
#endif /* not HAVE_X_WINDOWS */


/* ---------------------------------------------------------- */
/*  Hangul scanning for BUFFER, DISPLAY, and other operation  */
/* ---------------------------------------------------------- */

int
char_kind_in_current_buffer_line (beg, here)
     int beg, here;
{
  int curknd, pos = beg;

  if (beg > here)
    return ck_error;

  do {
    if (FETCH_CHAR (pos) & 0x80)
      {
	curknd = ck_han1;
	pos += 2;
      }
    else
      {
	curknd = ck_ascii;
	pos++;
      }
  } while (pos <= here);

  if (pos == here + 1 && curknd == ck_han1)
    curknd = ck_han2;

  /* if HERE == ZV and POS reach ZV+1, we must cancel the value of CURKND */
  if (pos > ZV)
    curknd = ck_error;

  return curknd;
}

int
char_kind_in_current_buffer (pos)
     int pos;
{
  if (pos < BEGV || pos > ZV)
    return 0;

  return char_kind_in_current_buffer_line (find_next_newline (pos, -1), pos);
}

#if 0
int
char_kind_in_current_buffer_line (beg, here)
     int beg, here;
{
  int curknd = ck_ascii, tmpknd;
  int pos = beg;

  if (beg > here)
    return ck_error;

  do {
    curknd = (curknd == ck_han1 ? ck_han2 : (!(FETCH_CHAR (pos) & 0x80) ? ck_ascii : ck_han1));
  } while (here != pos++);

  /* if HERE == ZV and POS reach ZV+1, we must cancel the value of CURKND */
  if (pos > ZV)
    curknd = ck_error;

  return curknd;
}

int
char_kind_in_current_buffer (pos)
     int pos;
{
  if (pos < BEGV || pos > ZV)
    return 0;

  return char_kind_in_current_buffer_line (find_next_newline (pos, -1), pos);
}
#endif

/* Efficient hangul-scanning procedure.
 *
 * method 1. Use the 'SKIP' count.
 * method 2. Precache line information.
 */

static char buffer_ck_cache[MAX_CKCACHE];
static int bcc;
static int rbeg;

void
init_ckcache_in_current_buffer (void)
{
  bcc = 0;
  rbeg = -1;
}

/* 'BEG' must be starting point of the line */
int
lookup_ck_in_current_buffer (beg, pos)
     int beg, pos;
{
  int npos;
  int index = pos - beg;

  if (beg < BEGV || pos > ZV || index < 0)
    return -1;

  /* Precaching can't handle it. */
  if (index >= MAX_CKCACHE)
    return char_kind_in_current_buffer_line (beg, pos);

  if (rbeg != beg || !bcc) /* initialize line informations */
    {
      buffer_ck_cache[0] = (FETCH_CHAR (beg) & 0x80) ? ck_han1 : ck_ascii;
      for (bcc=1, npos=beg+1; bcc < index+1; bcc++, npos++)
	buffer_ck_cache[bcc] = (buffer_ck_cache[bcc-1] == ck_han1 ? ck_han2 :
			(FETCH_CHAR (npos) & 0x80) ? ck_han1 : ck_ascii);
      rbeg = beg;
    }
  else if (index >= bcc) /* breed line informations */
    {
      for (npos=beg+bcc; bcc < index+1; bcc++, npos++)
	buffer_ck_cache[bcc] = (buffer_ck_cache[bcc-1] == ck_han1 ? ck_han2 :
			(FETCH_CHAR (npos) & 0x80) ? ck_ascii : ck_han1);
    }

  return buffer_ck_cache[index];
}

int
adjust_hangul_del_range (pos, dir)
     int pos, dir;
{
  return (char_kind_in_current_buffer (pos) != ck_han2 ? 0 : (dir ? 1 : -1));
}

int
char_kind_in_given_glyphs (str, here)
     GLYPH *str;
     int here;
{
  int curknd, pos = 0;

  if (here < 0)
    return ck_error;

  do {
    if (str[pos] & 0x80)
      {
	curknd = ck_han1;
	pos += 2;
      }
    else
      {
	curknd = ck_ascii;
	pos++;
      }
  } while (pos <= here);

  if (pos == here + 1 && curknd == ck_han1)
    curknd = ck_han2;

  return curknd;
}

/*
void
ck_count_in_given_glyphs (str, here, cnt, hcnt)
     GLYPH *str;
     int here;
     int *cnt, *hcnt;
{
  int pos = 0;

  if (here < 0)
    {
      *cnt = -1;
      *hcnt = 0;
    }

  while (pos < here)
    {
      if (str[pos] & 0x80)
	{
	  pos += 2;
	  (*hcnt)++;
	}
      else
	{
	  pos++;
	  (*cnt)++;
	}
    }
}
*/

static char string_ck_cache[MAX_CKCACHE];
static int scc;

int
init_ckcache_in_given_string (str, len)
     unsigned char *str;
     int len;
{
  /* Precaching can't handle it. */
  if (len > MAX_CKCACHE)
    return 0;

  string_ck_cache[0] = (str[0] & 0x80) ? ck_han1 : ck_ascii;
  for (scc = 1; scc < len; scc++)
    string_ck_cache[scc] = (string_ck_cache[scc-1] == ck_han1 ? ck_han2 :
		    (str[scc] & 0x80) ? ck_han1 : ck_ascii);
  return 1;
}

int
lookup_ck_in_given_string (index)
     int index;
{
  if (index < 0 || index >= scc)
    return 0;
  else
    return string_ck_cache[index];
}

int
char_kind_in_given_string (str, here)
     unsigned char *str;
     int here;
{
  int curknd, pos = 0;

  if (here < 0)
    return ck_error;

  do {
    if (str[pos] & 0x80)
      {
	curknd = ck_han1;
	pos += 2;
      }
    else
      {
	curknd = ck_ascii;
	pos++;
      }
  } while (pos <= here);

  if (pos == here + 1 && curknd == ck_han1)
    curknd = ck_han2;

  return curknd;
}

#if 0
int
char_kind_in_given_glyphs (str, here)
     GLYPH *str;
     int here;
{
  int curknd = ck_ascii, tmpknd;
  int pos = 0;

  if (here < 0)
    return ck_error;

  do {
    curknd = (curknd == ck_han1 ? ck_han2 : (!(str[pos] & 0x80) ? ck_ascii : ck_han1));
  } while (here != pos++);

  return curknd;
}

int
char_kind_in_given_string (str, here)
     unsigned char *str;
     int here;
{
  int curknd = ck_ascii, tmpknd;
  int pos = 0;

  if (here < 0)
    return ck_error;

  do {
    curknd = (curknd == ck_han1 ? ck_han2 : (!(str[pos] & 0x80) ? ck_ascii : ck_han1));
  } while (here != pos++);
  
  return curknd;
}
#endif

int
adjust_hangul_display_range (str, pos, dir)
     GLYPH *str;
     int pos, dir;
{
  int curknd = char_kind_in_given_glyphs (str, pos-1);
  return (curknd == ck_han1 ? (dir ? 1 : -1) : (curknd == ck_han2 ? (dir ? 0 : -2) : 0));
}

#if 0
int
adjust_hangul_display_range (str, pos, dir)
     GLYPH *str;
     int pos, dir;
{
  int curknd, i;
  unsigned char buf[100];

  if (dir)
    fprintf (stderr, "%s%d:", "R", pos);
  else
    fprintf (stderr, "%s%d:", "L", pos);

  for (i = 0; i <= pos; i++)
    buf[i] = (unsigned char) str[i];
  buf[i] = '\0';
  fprintf (stderr, "%s", buf);

  curknd = char_kind_in_given_glyphs (str, pos-1);
  fprintf (stderr, ":%d\n", curknd);
  return (curknd == ck_han1 ? (dir ? 1 : -1) : (curknd == ck_han2 ? (dir ? 0 : -2) : 0));
}
#endif

void 
syms_of_hangul ()
{
  DEFVAR_INT ("han-johab-mode", &han_johab_mode,
	      "ѱ  ̸ 1, ѱ ϼ ̸ 0 ´");
  han_johab_mode = 0;

  DEFVAR_INT ("han-kbd-kind", &han_kbd_kind,
	      "ѱ  2̸ 2, 3̸ 3 ´");
  han_kbd_kind = 2;

  DEFVAR_INT ("han-kbd-state", &han_kbd_state,
	      "ѱ Է ̸ 1,  Է ̸ 0 ´");
  han_kbd_state = 0;
  han_old_kbd_state = 0;

  DEFVAR_INT ("han-code-state", &han_code_state,
	      "  ѱ ڵ ¸ Ÿ  ´");
  han_code_state = 0;

  defsubr (&Shan_activate_automata);
  defsubr (&Shan_reactivate_automata);
  defsubr (&Shan_init_automata);
}
