/* ѱ pattern matching.
   Copyright (C) 1994, 95, 96 ϴϸ  (fpf545@dosa1.snu.ac.kr).

   Emacs ҽ ڵ忡 ѱ ó   κ hanemacs 
   ũθ ϰ ֽϴ.  κ   ȭϰ Բ 
   ϴϸ ҽ ڵ ֵ˴ϴ.

HanEmacs is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

HanEmacs is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Emacs; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <config.h>
#include "lisp.h"
#include "intervals.h"
#include "buffer.h"

#include "hangul.h"

#define TRUE  1
#define FALSE 0

unsigned char jongcho_match_table_2 [2][32] =
{
  /* 0  1  2  3  4  5  6  7  8  9  0  1  2  3  4  5 */
  /* 6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1 */
  {  0, 0, 1, 2, 2, 1, 5, 5, 1, 1, 9, 9, 9, 9, 9, 9,
     9, 1, 0, 1,19, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0 },
  {  0, 0, 2, 3,11, 4,14,20, 5, 7, 2, 8, 9,11,18,19,
    20, 8, 0, 9,11,11,12,13,14,16,17,18,19,20, 0, 0 }
};

unsigned char jungsung_match_table_2 [3][32] =
{
  /*    ()  : 13 14 15 (16 17) 18 */
  /*     : 20 21 22 23 */
  /*   : 27 28 */
  /* 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 */
  {  0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0 },
  {  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0 },
  {  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0 }
};

unsigned char jongsung_match_table_2 [4][32] =
{
  /*  ()  : 2 (3) 4 */
  /*    : 5 6 7 */
  /*        : 9 10 11 12 13 14 15 16 */
  /*  : 19 20 */
  /* 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 */
  {  0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
  {  0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
  {  0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
  {  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0 }
};

unsigned char jongsung_match_table_3 [3][32] =
{
  /*  ()  : 2 (3) 4 */
  /*   [] : 5 6 [7] */
  /* [ ]     [] : 9 [10 11] 12 13 14 15 [16] */
  /*  : [19 20] */
  /* 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 */
  {  0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
  {  0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 },
  {  0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
/*  {  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0 } */
};


static int han_search_exact;

static int 
match_pattern_2 (code1, code2, state, pos)
     unsigned code1, code2;
     int state, pos;
{
  unsigned ff1, ss1, tt1, tmp;
  unsigned ff2, ss2, tt2;
  int val;

  ff1 = (code1 & 0x7c00) >> 10;
  ss1 = (code1 & 0x03e0) >> 5;
  tt1 = code1 & 0x001f;

  ff2 = (code2 & 0x7c00) >> 10;
  ss2 = (code2 & 0x03e0) >> 5;
  tt2 = code2 & 0x001f;

  if (state == johab_chosung)
    val = (ff1 == ff2 ? TRUE : FALSE);

  else if (state == johab_jungsung)
    {
      if (ff1 == ff2) 
	{
	  switch (ss2) 
	    {
	    case 13 :
	      val = jungsung_match_table_2 [0][ss1];
	      break;
	    case 20 : 
	      val = jungsung_match_table_2 [1][ss1];
	      break;
	    case 27 : 
	      val = jungsung_match_table_2 [2][ss1];
	      break;
	    default :
	      val = (ss1 == ss2 ? TRUE : FALSE);
	    }
	}
      else
	val = FALSE;
    }
  else if (state == johab_jongsung)
    {
      if (ff1 == ff2 && ss1 == ss2) 
	{
	  switch (tt2) 
	    {
	    case 2 : 
	      val = jongsung_match_table_2 [0][tt1];
	      break;
	    case 5 : 
	      val = jongsung_match_table_2 [1][tt1];
	      break;
	    case 9 : 
	      val = jongsung_match_table_2 [2][tt1];
	      break;
	    case 19 : 
	      val = jongsung_match_table_2 [3][tt1];
	      break;
	    default :
	      val = (tt1 == tt2 ? TRUE : FALSE);
	    }

	  /*    ʼ  */
	  if (val == FALSE && pos < ZV && !han_search_exact)
	    {
	      if (!(FETCH_CHAR (pos) & 0x80))
		goto done;

	      if (!(tmp = make_jcode_with_string (&FETCH_CHAR (pos))))
		goto done;

	      if (jongcho_match_table_2 [0][tt2] == tt1 &&
		  jongcho_match_table_2 [1][tt2] == ((tmp & 0x7c00) >> 10))
		val = TRUE;
	      else
		val = FALSE;
	    }
	}
      else
	val = FALSE;
    }
  else if (state == johab_only_jungsung)
    val = (ss1 == ss2 ? TRUE : FALSE);

  else if (state == johab_only_jongsung)
    val = (tt1 == tt2 ? TRUE : FALSE);

 done:
  return val;
}

static int 
match_pattern_3 (code1, code2, state)
     unsigned code1, code2;
     int state;
{
  unsigned ff1, ss1, tt1, tmp;
  unsigned ff2, ss2, tt2;
  int val;

  ff1 = (code1 & 0x7c00) >> 10;
  ss1 = (code1 & 0x03e0) >> 5;
  tt1 = code1 & 0x001f;

  ff2 = (code2 & 0x7c00) >> 10;
  ss2 = (code2 & 0x03e0) >> 5;
  tt2 = code2 & 0x001f;

  if (state == johab_chosung)
    {
      switch (ff2) 
	{
	case 2 : /* : 2 3 */
	case 5 : /* : 5 6 */
	case 9 : /* : 9 10 */
	case 11 : /* : 11 12 */
	case 14 : /* : 14 15 */
	  val = (ff1 == ff2 + 1 ? TRUE : FALSE);
	}
      if (val == FALSE)
	val = (ff1 == ff2 ? TRUE : FALSE);
    }
  else if (state == johab_jungsung)
    {
      if (ff1 == ff2) 
	{
	  switch (ss2) 
	    {
	    case 13 :
	      val = jungsung_match_table_2 [0][ss1];
	      break;
	    case 20 : 
	      val = jungsung_match_table_2 [1][ss1];
	      break;
	    case 27 : 
	      val = jungsung_match_table_2 [2][ss1];
	      break;
	    default :
	      val = (ss1 == ss2 ? TRUE : FALSE);
	    }
	}
      else
	val = FALSE;
    }
  else if (state == johab_jongsung)
    {
      if (ff1 == ff2 && ss1 == ss2) 
	{
	  switch (tt2) 
	    {
	    case 2 : 
	      val = jongsung_match_table_3 [0][tt1];
	      break;
	    case 5 : 
	      val = jongsung_match_table_3 [1][tt1];
	      break;
	    case 9 : 
	      val = jongsung_match_table_3 [2][tt1];
	      break;
	    default :
	      val = (tt1 == tt2 ? TRUE : FALSE);
	    }
	}
      else
	val = FALSE;
    }
  else if (state == johab_only_jungsung)
    val = (ss1 == ss2 ? TRUE : FALSE);

  else if (state == johab_only_jongsung)
    val = (tt1 == tt2 ? TRUE : FALSE);
  
  return val;
}

int 
match_pattern (code1, code2, jstate, pos)
     unsigned code1, code2;
     int jstate, pos;
{
  return (han_kbd_kind  == 3 ? match_pattern_3 (code1, code2, jstate) 
	  : match_pattern_2 (code1, code2, jstate, pos));
}

void 
syms_of_hansrch ()
{
  DEFVAR_INT ("han-search-exact", &han_search_exact,
	      "ѱ Ž     񱳸 ݵ ϰ Ѵ");
  han_search_exact = 0;
}
